unit UnFalsoColor;

interface
uses
  Windows,SysUtils, Variants, Classes, Graphics,
  math, UApoyo;

  procedure FC_PaletaA (Ma : Mat3D   ; var Mb :Mat3D;
                        par : vect_5p; np : integer  );

implementation

  procedure FC_PaletaA (Ma : Mat3D  ; var Mb : Mat3D;
                        par : vect_5p; np : integer  );
  var
    x,y,can : integer;
    m, b    : array [0..3] of single;
    tt      : single;

    //  a' a  c  b   b'
    //  0  1  2  3   4

  begin
    // verde
    m[2] := par[2]/par[0];         //  c/a'
    b[2] := par[2] - m[2]*127;     //  b = y'' - m*x''

    m[3] := -par[2]/(par[4]-127);  //  (0-c)/(b'-127)
    b[3] := par[2] - m[3]*127;     //   b = y'' - m*x''

    // rojo
    m[0] := -255/par[3];           //  (0-lamb)/b
    b[0] :=  - m[0]*par[3];        //  b' = y'' - m*x''

    // azul
    m[1] := 255/par[1];           //   (lamb-0)/a
    b[1] :=  - m[1]*par[1];        //  b = y'' - m*x''

    // ------------------

    // aplica reglas
    for y := _y1 to _y2 - 1 do
      for x := _x1 to _x2 - 1 do begin
      // ---
        // rojo
        tt := Ma.dat[x][y][0];

        if (tt<par[3])
          then Mb.dat[x][y][0] := m[0]*tt+b[0]
          else Mb.dat[x][y][0] := 0;


        // verde
        tt := Ma.dat[x][y][1];

        if (tt>par[0] ) and (tt<par[2])
          then Mb.dat[x][y][1] := m[2]*tt+b[2]
          else if (tt>par[2]) and (tt<par[4])
            then Mb.dat[x][y][1] := m[3]*tt+b[3]
            else Mb.dat[x][y][1] := 0;

        // azul
        tt := Ma.dat[x][y][2];

        if (tt>par[1])
          then Mb.dat[x][y][2] := m[1]*tt+b[1]
          else Mb.dat[x][y][2] := 0;
      // ---

  end;
  end;
end.
